#
# Licensed Materials - Property of IBM
# Rational ClearQuest
# (C) Copyright IBM Corp. 2008.  All Rights Reserved
# US Government Users Restricted Rights
# Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
#

import sys, java, string

#-----------------------------------------------------------------
# Sets JVM's variable for solr.solr.home
#-----------------------------------------------------------------
def setSolrHome(interactive, solrHome):

    global AdminApp
    global AdminConfig

    solrJvmParameters = "-Dsolr.solr.home=" + solrHome
    
    server1 = AdminConfig.getid('/Server:server1/JavaProcessDef:/JavaVirtualMachine:/')
    jvm = AdminConfig.list('JavaVirtualMachine', server1)

    existingGenericJvmArguments = AdminConfig.showAttribute(jvm, 'genericJvmArguments')

    newGenericJvmArguments = solrJvmParameters

    print ""
    print "This script change 'genericJvmArguments' to set 'solr.solr.home'"
    print ""
    print "Current setting for 'genericJvmArguments' is: " + existingGenericJvmArguments

    items = string.split(existingGenericJvmArguments, " ")

    # Walk through existing items and replace 'solr.solr.home's value
    if len(items) >= 1:
        for item in items:
            keyVal = string.split(item, "=")
            if len(keyVal) == 2:
                if keyVal[0] == "-Dsolr.solr.home":
                    continue    # skip over 'solr.solr.home' since we are trying to replace it
            newGenericJvmArguments += " " + item

    # Give the user a chance to edit the raw data
    while 1:
        if interactive == "-interactive:no":
            break   # don't be interactive

        print ""
        print "New setting for 'genericJvmArguments' is: " + newGenericJvmArguments

        userResponse = raw_input("Do you want to modify it? (y/n): ")

        if userResponse == "n":
            break
        else:
            newGenericJvmArguments = raw_input("Enter new value: ")

    AdminConfig.modify(jvm, [['genericJvmArguments', newGenericJvmArguments]])

    AdminConfig.save()

    print ""
    print "'genericJvmArguments' was changed to: " + newGenericJvmArguments
    print ""
    print "The 'cqsearchprofile' MUST be restarted for this change to take effect."


#-----------------------------------------------------------------
# Main
#-----------------------------------------------------------------
if (len(sys.argv) != 2):
    print "This script will change the java system property to include 'solr.solr.home'"
    print "In doing so, it will change the value of 'genericJvmArguments' in your server.xml file"
    print ""
    print "This script requires 2 parameter: "
    print "	  1) -interactive:[yes | no]"
    print "	  2) the full path to what solr.solr.home should be set to"
    print ""
    print "e.g.:     setSolrHome -interactive:yes /CQ.Solr/SAMPL/Solr/solr"
else:
    setSolrHome(sys.argv[0], sys.argv[1])
